<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
	<title>MQTT Configuration</title>

	<link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

	<script src='../js/meti_merged.js'></script>
	<script src='../js/meti_utils.js'></script>

	<style>
		html {
			visibility: hidden;
		}
	</style>

</head>

<body>
	<div w3-include-html="meti_bst.html"></div>

	<div class="container">
		<div class="row">
			<main role="main" class="col-sm-12 col-md-8 col-lg-6 pt-2">
				<h5 class="p-1">MQTT Configuration</h5>
				<form id="formID">
					<div class="border border-primary p-2">
						<!-- Enable MQTT -->
						<div class="input-group p-0 m-1 row">
							<div class="input-group-prepend">
								<div class="input-group-text">
									<input type="checkbox" id="mqtt_enabled">
								</div>
							</div>
							<label type="text" class="form-control">Enable MQTT</label>
						</div>

						<div class="mqtt_settings">
							<!-- Packet version -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="packet_version">Packet version</label>
								<input type="text" id="packet_version" class="col-6 form-control form-control-sm"
									readonly>
							</div>

							<!-- Server -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_server">Server</label>
								<input type="text" id="sel_server" name="sel_server"
									class="col-6 form-control form-control-sm"
									data-validation-engine="validate[required], maxSize[32]">
							</div>

							<!-- Client ID -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_clientId">Client ID</label>
								<input type="text" id="sel_clientId" name="sel_clientId"
									class="col-6 form-control form-control-sm" readonly>
							</div>

							<!-- MQTT Server Username -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_username">Username</label>
								<input type="text" id="sel_username" name="sel_username"
									class="col-6 form-control form-control-sm"
									data-validation-engine="validate[required], maxSize[24]">
							</div>

							<!-- MQTT Password -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_password">Password</label>
								<input type="password" id="sel_password" name="sel_password" value="test_pw"
									class="col-6 form-control form-control-sm"
									data-validation-engine="validate[required] maxSize[24]">
							</div>

							<!-- MQTT Port -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_port">Port</label>
								<input type="text" id="sel_port" name="sel_port" value="1883"
									class="col-6 form-control form-control-sm"
									data-validation-engine="validate[required, custom[integer], min[1], max[9999]">
							</div>

							<!-- Keep Alive -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_keep_alive">Keep Alive (Seconds)</label>
								<select class="col-6 form-control form-control-sm" id="sel_keep_alive"
									name="sel_keep_alive" size="1">
								</select>
								<!-- <input type="text" id="sel_keep_alive" name="sel_keep_alive" value=600
                                    class="col-6 form-control form-control-sm"
                                    data-validation-engine="validate[required] custom[integer], min[0], max[900]"> -->
							</div>

							<!-- QOS -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_qos">QOS</label>
								<select class="col-6 form-control form-control-sm" id="sel_qos" name="sel_qos" size="1">
								</select>
								<!-- <input type="text" id="sel_qos" name="sel_qos" value="2"
                                    class="col-6 form-control form-control-sm"
                                    data-validation-engine="validate[required] custom[integer], min[0], max[2]"> -->
							</div>

							<!-- User/Topic Password -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_topic_pw">User/Topic Password</label>
								<input type="text" id="sel_topic_pw" name="sel_topic_pw" value="test_pw"
									class="col-6 form-control form-control-sm"
									data-validation-engine="validate[required] maxSize[24]">
							</div>

							<!-- Publish interval -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_pi">Publish interval</label>
								<select class="col-6 form-control form-control-sm" id="sel_pi" name="sel_pi" size="1">
								</select>
							</div>
						</div>

						<div class="col-sm-12 form-group row mt-4 mb-1">
							<button type="button" id="button_cancel"
								class="btn btn-warning col ml-4 mr-4">Cancel</button>
							<button type="button" id="button_save" class="btn btn-success col ml-4 mr-4">Save</button>
						</div>
					</div>
				</form>
			</main>
		</div>
</body>
</html>

<script>
	w3IncludeHTML();

	$(document).ready(function () {
		// display all items
		document.getElementsByTagName("html")[0].style.visibility = "visible";

		setupSelects();

		function setupSelects() {
			//keep alive
			dataArray = [30, 60, 120, 180, 300, 600]
			for (idx = 0; idx < dataArray.length; idx++) {
				var opt = $('<option></option>')
					.val(dataArray[idx])
					.addClass('dropdown-item')
					.addClass('dd-item')
					.text(dataArray[idx] + ' secs');

				$("#sel_keep_alive").append(opt);
			}

			//MQTT QOS (Quality of Service)
			dataArray = [0, 1, 2]
			for (idx = 0; idx < dataArray.length; idx++) {
				var opt = $('<option></option>')
					.val(dataArray[idx])
					.addClass('dropdown-item')
					.addClass('dd-item')
					.text(dataArray[idx]);

				$("#sel_qos").append(opt);
			}

			//publish interval
			dataArray = [30, 60, 120, 300, 900, 1800, 3600]
			for (idx = 0; idx < dataArray.length; idx++) {
				var opt = $('<option></option>')
					.val(dataArray[idx])
					.addClass('dropdown-item')
					.addClass('dd-item')
					.text(dataArray[idx] + ' secs');

				$("#sel_pi").append(opt);
			}
		}

		$("#button_save").on("click", function () {
			if ($("#formID").validationEngine('validate')) {
				var r = confirm("Save MQTT configuration?");
				if (r == true) {
					save_config();
				}
			}
		});

		$("#button_cancel").on("click", function () {
			document.location.href = "index.html";
		});

		$("#mqtt_enabled").on("click", function () {
			enable_disable();
		});

		function enable_disable() {
			if ($('#mqtt_enabled').is(":checked") == true) {
				$(".mqtt_settings :input").attr("disabled", false);
			} else {
				$(".mqtt_settings :input").attr("disabled", true);
			}
		}

		function load_form_data() {
			$("#packet_version").val(g_mqtt_db.pkt_ver);
			$('#mqtt_enabled').prop("checked", g_mqtt_db.enabled);
			$("#sel_server").val(g_mqtt_db.server);
			$("#sel_port").val(g_mqtt_db.port);
			$("#sel_keep_alive").val(g_mqtt_db.ka);
			$("#sel_username").val(g_mqtt_db.un);
			$("#sel_password").val(g_mqtt_db.pw);
			$("#sel_qos").val(g_mqtt_db.qos);
			$("#sel_topic_pw").val(g_mqtt_db.t_pw);

			// If read interval is not there in the list, choose 60 seconds
			if ($("#sel_pi option[value=" + g_mqtt_db.pi + "]").length == 0) {
				$("#sel_pi").val(60);
			} else {
				$("#sel_pi").val(g_mqtt_db.pi);
			}

			enable_disable();
		}

		function save_config() {
			var debug = 0;

			g_mqtt_db.enabled = $("#mqtt_enabled").is(":checked");
			g_mqtt_db.server = $("#sel_server").val();
			g_mqtt_db.port = $("#sel_port").val();
			g_mqtt_db.ka = $("#sel_keep_alive").val();
			g_mqtt_db.un = $("#sel_username").val();
			g_mqtt_db.pw = $("#sel_password").val();
			g_mqtt_db.qos = $("#sel_qos").val();
			g_mqtt_db.t_pw = $("#sel_topic_pw").val();
			g_mqtt_db.pi = $("#sel_pi").val();

			var url = "/updateMqttConfig";
			var type = 'POST';
			var data = {
				mqtt: JSON.stringify(g_mqtt_db)
			};

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					if (debug == 1) {
						console.log(response);
					}
					else {
						// console.log(js_response);
						var result = response.result;

						if (result == 1) {
							alert(response.message);
						}
						else if (result == 0) {
							alert(response.message);
						}
					}
				},
				error: function (jqXHR, exception, response) {
					alert('POST Error!');
				}
			});
		}

		function noSensorData(response) {
			console.log("POST Error...")
		}

		function updateDevicesParams(response) {
			$("#sel_clientId").val(response.dev_id);
		}
		//********* Call all start up functions after this line *******//

		setTimeout(function () {
			getDeviceParams(updateDevicesParams, noSensorData);
		}, 500);

		setTimeout(function () {
			readMqttConfigFromFS(load_form_data);
		}, 750);

		$("#formID").validationEngine();
	});

</script>